"""DTML Document Site Search Extension"""

from sgmllib import SGMLParser
from string import join
import re

# Code taken from Dieter Maurer's CatalogSupport Module
# http://www.handshake.de/~dieter/pyprojects/zope
# Thank you!

class _StripTagParser(SGMLParser):
  '''SGML Parser removing any tags and translating HTML entities.'''

  from htmlentitydefs import entitydefs

  data= None

  def handle_data(self,data):
    if self.data is None: self.data=[]
    self.data.append(data)

  def __str__(self):
    if self.data is None: return ''
    return join(self.data,'')

dtml_comment_re = re.compile('<dtml-comment>.*</dtml-comment>',re.S)
html_head_re = re.compile('(?:<head>|<HEAD>).*(?:</head>|</HEAD>)',re.S)
whitespace_re = re.compile('^\\W*')

def StripTags(data):
    """Convert html data to raw text"""

    p = _StripTagParser()

    try:
        data = dtml_comment_re.sub('', data) # Strip dtml comments
        data = html_head_re.sub('', data) # Strip HTML head
        p.feed(data)
        p.close()
        p = str(p)
        p = whitespace_re.sub('', p) # trim leading whitespace
        return str(p)
    except:
        return ''
